#/usr/bin/python
# -*- coding: utf-8 -*-

class PointOfIntersection(object):
	def __init__(self, dist, norm):
		self.dist = dist
		self.norm = norm

class PointsOfIntersection(object):
	def __init__(self, ray, *points):
		self.ray = ray
		self.points = list(points)
	
	def addPoints(self, *points):
		for p in points:
			self.addPoint(*p)
	
	def addPoint(self, dist, norm):
		self.points.append(PointOfIntersection(dist, norm))
	
	def append(self, point):
		self.points.append(point)
	
	def getDistAndNormOfNearestToRayStart(self):
		points = []
		for p in self.points:
			if p.dist >= 0:
				points.append(p)
		
		if len(points) > 0:
			minDist = points[0].dist
			minNorm = points[0].norm
			
			for p in points:
				if p.dist < minDist:
					minDist = p.dist
					minNorm = p.norm
			
			return minDist, minNorm
		else:
			return None
	
	def anyIsBeyondRayStart(self):
		for p in self.points:
			if p.dist > 0:								# maybe add tolerance here, because of numerical calculation errors
				return True
		
		return False
	
	def getAllBeyondRayStart(self):
		points = self.points[:]
		for i in range(len(points)-1, -1, -1):
			if points[i].dist <= 0: 				# maybe add tolerance here, because of numerical calculation errors
				del points[i]
		
		return PointsOfIntersection(self.ray, *points)
	
	def __len__(self):
		return len(self.points)

#for i in range(len(objInter)-1, -1, -1):
#	if objInter[i]-TOLERANCE <= 0:
#		del objInter[i]
